miiselector.h File Reference

Mii Selector Applet (appletEd). More...

`#include <3ds/types.h>`
`#include <3ds/mii.h>`

Go to the source code of this file.

## Data Structures

struct | MiiSelectorConf
| Parameter structure passed to AppletEd. More...
struct | MiiSelectorReturn
| Structure written by AppletEd. More...

## Macros

#define | MIISELECTOR_MAGIC 0x13DE28CF
| Magic value needed to launch the applet.
#define | MIISELECTOR_TITLE_LEN 64
| Maximum length of title to be displayed at the top of the Mii selector applet.
#define | MIISELECTOR_GUESTMII_SLOTS 6
| Number of Guest Miis available for selection.
#define | MIISELECTOR_USERMII_SLOTS 100
| Maximum number of user Miis available for selection.
#define | MIISELECTOR_GUESTMII_NAME_LEN 12
| Maximum length of the localized name of a Guest Mii.

## Enumerations

enum | { MIISELECTOR_CANCEL = BIT(0) , MIISELECTOR_GUESTS = BIT(1) , MIISELECTOR_TOP = BIT(2) , MIISELECTOR_GUESTSTART = BIT(3) }
| AppletEd options. More...

## Functions

void | miiSelectorInit (MiiSelectorConf *conf)
| Initialize Mii selector config. More...
void | miiSelectorLaunch (const MiiSelectorConf *conf, MiiSelectorReturn *returnbuf)
| Launch the Mii selector library applet. More...
void | miiSelectorSetTitle (MiiSelectorConf *conf, const char *text)
| Sets title of the Mii selector library applet. More...
void | miiSelectorSetOptions (MiiSelectorConf *conf, u32 options)
| Specifies which special options are enabled in the Mii selector. More...
void | miiSelectorWhitelistGuestMii (MiiSelectorConf *conf, u32 index)
| Specifies which guest Miis will be selectable. More...
void | miiSelectorBlacklistGuestMii (MiiSelectorConf *conf, u32 index)
| Specifies which guest Miis will be unselectable. More...
void | miiSelectorWhitelistUserMii (MiiSelectorConf *conf, u32 index)
| Specifies which user Miis will be selectable. More...
void | miiSelectorBlacklistUserMii (MiiSelectorConf *conf, u32 index)
| Specifies which user Miis will be selectable. More...
static void | miiSelectorSetInitialIndex (MiiSelectorConf *conf, u32 index)
| Specifies which Mii the cursor should start from. More...
void | miiSelectorReturnGetName (const MiiSelectorReturn *returnbuf, char *out, size_t max_size)
| Get Mii name. More...
void | miiSelectorReturnGetAuthor (const MiiSelectorReturn *returnbuf, char *out, size_t max_size)
| Get Mii Author. More...
bool | miiSelectorChecksumIsValid (const MiiSelectorReturn *returnbuf)
| Verifies that the Mii data returned from the applet matches its checksum. More...

## Detailed Description

Mii Selector Applet (appletEd).

## Enumeration Type Documentation

## anonymous enum

anonymous enum

AppletEd options.

Enumerator
MIISELECTOR_CANCEL | Show the cancel button.
MIISELECTOR_GUESTS | Make Guets Miis selectable.
MIISELECTOR_TOP | Show AppletEd on top screen.
MIISELECTOR_GUESTSTART | Start on guest page.

## Function Documentation

## miiSelectorBlacklistGuestMii()

void miiSelectorBlacklistGuestMii | ( | MiiSelectorConf * | conf,
|  | u32 | index
| ) |  |

Specifies which guest Miis will be unselectable.

Parameters

  conf | Pointer to miiSelector configuration
  index | Index of the guest Miis that will be blacklisted. MIISELECTOR_GUESTMII_SLOTS can be used to blacklist all the guest Miis.

## miiSelectorBlacklistUserMii()

void miiSelectorBlacklistUserMii | ( | MiiSelectorConf * | conf,
|  | u32 | index
| ) |  |

Specifies which user Miis will be selectable.

Parameters

  conf | Pointer to miiSelector configuration
  index | Index of the user Miis that will be blacklisted. MIISELECTOR_USERMII_SLOTS can be used to blacklist all the user Miis

## miiSelectorChecksumIsValid()

bool miiSelectorChecksumIsValid | ( | const MiiSelectorReturn * | returnbuf | ) |

Verifies that the Mii data returned from the applet matches its checksum.

Parameters

  returnbuf | Buffer filled by Mii selector applet

Returns
  `true` if `returnbuf->checksum` is the same as the one computed from `returnbuf`

## miiSelectorInit()

void miiSelectorInit | ( | MiiSelectorConf * | conf | ) |

Initialize Mii selector config.

Parameters

  conf | Pointer to Miiselector config.

## miiSelectorLaunch()

void miiSelectorLaunch | ( | const MiiSelectorConf * | conf,
|  | MiiSelectorReturn * | returnbuf
| ) |  |

Launch the Mii selector library applet.

Parameters

  conf | Configuration determining how the applet should behave

## miiSelectorReturnGetAuthor()

void miiSelectorReturnGetAuthor | ( | const MiiSelectorReturn * | returnbuf,
|  | char * | out,
|  | size_t | max_size
| ) |  |

Get Mii Author.

Parameters

  returnbuf | Pointer to miiSelector return
  out | String containing a Mii's author
  max_size | Size of string. Since UTF8 characters range in size from 1-3 bytes (assuming that no non-BMP characters are used), this value should be 30.

## miiSelectorReturnGetName()

void miiSelectorReturnGetName | ( | const MiiSelectorReturn * | returnbuf,
|  | char * | out,
|  | size_t | max_size
| ) |  |

Get Mii name.

Parameters

  returnbuf | Pointer to miiSelector return
  out | String containing a Mii's name
  max_size | Size of string. Since UTF8 characters range in size from 1-3 bytes (assuming that no non-BMP characters are used), this value should be 36 (or 30 if you are not dealing with guest miis).

## miiSelectorSetInitialIndex()

static void miiSelectorSetInitialIndex | ( | MiiSelectorConf * | conf,
|  | u32 | index
| ) |  |

inlinestatic

Specifies which Mii the cursor should start from.

Parameters

  conf | Pointer to miiSelector configuration
  index | Indexed number of the Mii that the cursor will start on. If there is no mii with that index, the the cursor will start at the Mii with the index 0 (the personal Mii).

## miiSelectorSetOptions()

void miiSelectorSetOptions | ( | MiiSelectorConf * | conf,
|  | u32 | options
| ) |  |

Specifies which special options are enabled in the Mii selector.

Parameters

  conf | Pointer to miiSelector configuration
  options | Options bitmask

## miiSelectorSetTitle()

void miiSelectorSetTitle | ( | MiiSelectorConf * | conf,
|  | const char * | text
| ) |  |

Sets title of the Mii selector library applet.

Parameters

  conf | Pointer to miiSelector configuration
  text | Title text of Mii selector

## miiSelectorWhitelistGuestMii()

void miiSelectorWhitelistGuestMii | ( | MiiSelectorConf * | conf,
|  | u32 | index
| ) |  |

Specifies which guest Miis will be selectable.

Parameters

  conf | Pointer to miiSelector configuration
  index | Index of the guest Miis that will be whitelisted. MIISELECTOR_GUESTMII_SLOTS can be used to whitelist all the guest Miis.

## miiSelectorWhitelistUserMii()

void miiSelectorWhitelistUserMii | ( | MiiSelectorConf * | conf,
|  | u32 | index
| ) |  |

Specifies which user Miis will be selectable.

Parameters

  conf | Pointer to miiSelector configuration
  index | Index of the user Miis that will be whitelisted. MIISELECTOR_USERMII_SLOTS can be used to whitlist all the user Miis